local se = require "lib.samp.events" 
local playerNameOrId = ""
local lastCheckTime = 0
local shouldSendResponse = false

function openPhoneApp(appId)
    local str = ('launchedApp|%s'):format(appId)
    local bs = raknetNewBitStream()
    raknetBitStreamWriteInt8(bs, 220)
    raknetBitStreamWriteInt8(bs, 18)
    raknetBitStreamWriteInt8(bs, #str)
    raknetBitStreamWriteInt8(bs, 0)
    raknetBitStreamWriteInt8(bs, 0)
    raknetBitStreamWriteInt8(bs, 0)
    raknetBitStreamWriteString(bs, str)
    raknetBitStreamWriteInt32(bs, 0)
    raknetBitStreamWriteInt8(bs, 0)
    raknetBitStreamWriteInt8(bs, 0)
    raknetSendBitStreamEx(bs, 1, 7, 1)
    raknetDeleteBitStream(bs)
end

function executeWithDelay()
    sampSendChat("/phone")
    wait(500)
    openPhoneApp(33)
    wait(500)
    sampSendChat("/phone")
end

function main()
    while not isSampAvailable() do wait(0) end
    sampRegisterChatCommand('oldnick', function(args)
        playerNameOrId = args:match("^%s*(.-)%s*$")
        if playerNameOrId and playerNameOrId ~= "" then
            local currentTime = os.time()
            if currentTime - lastCheckTime < 15 then
                local remainingTime = 15 - (currentTime - lastCheckTime)
                sampAddChatMessage("[] {ffffff}         15 .    " .. remainingTime .. " .", 0x73B461)
                return
            end
            
            lastCheckTime = currentTime
            local id = tonumber(playerNameOrId)
            if id then
                if sampIsPlayerConnected(id) then
                    local nickname = sampGetPlayerNickname(id)
                    sampAddChatMessage("[] {ffffff}    " .. nickname .. ".", 0x73B461)
                    playerNameOrId = nickname
                else
                    sampAddChatMessage("[] {ffffff}  ID " .. id .. "  .", 0x73B461)
                    return
                end
            else
                sampAddChatMessage("[] {ffffff}    " .. playerNameOrId .. ".", 0x73B461)
            end
            
            shouldSendResponse = true
            lua_thread.create(executeWithDelay)
        else
            sampAddChatMessage("[] {ffffff} /oldnick [ID/Nick_Name].", 0x73B461)
        end
    end)
end

function se.onShowDialog(dialogId, style, title, button1, button2, text)
    if dialogId == 27273 and shouldSendResponse then
        sampSendDialogResponse(27273, 1, nil, playerNameOrId)
        shouldSendResponse = false
        return false
    end
end
